Dim seq As Byte  'rotary encoder sequence of bits
Dim bb As Byte  'rotary encoder current state
Dim pbb As Byte  'rotary encoder previous state
Dim vol As Byte  'volume level
Dim i As Byte  'loop counter for PWM
Dim ack As Bit  'ack bit from I2C communication
Dim i2 As Byte  'loop counter
Dim d As Byte  'temporary
Dim data As Byte  'data to send by I2C
Dim addr As Byte  'DAC attenuation register address
Dim ewc As Word  'eeprom write delay counter


Config RB4 = Input  'set SDA line high impedance
Config RB5 = Input  'set SCL line high impedance
RB4 = 0  'probably unnecessary
RB5 = 0

Read 0, vol  'read volume value from EEPROM address 0
RB3 = 1  'ACK LED off
Gosub sendvol  'send volume value to DAC
RB3 = ack  'ACK LED on if success

Config RA2 = Input  'rotary encoder inputs
Config RA3 = Input
Config RB3 = Output  'ACK LED output
Config RB2 = Output  'PWM volume level output

RB2 = 0  'PWM low
pbb = 0  'initiate variables
seq = 0
i = 0
ewc = 0

loop:
	bb.0 = RA2  'bit 0 of bb = rotary encoder switch 1 state
	bb.1 = RA3  'bit 1 of bb = rotary encoder switch 2 state
	If pbb <> bb Then  'if previous rotary encoder state diffrent than current - knob turned
		seq = ShiftLeft(seq, 2)  'shift sequence left 2 bytes
		seq = seq + bb  'place current rotary encoder state at the begining of sequence
		If seq = %01001011 Then  'if sequence corresponds to full click counterclockwise
			If vol > 0 Then vol = vol - 1  'reduce volume
			Gosub sendvol  'send volume value to DAC
			seq = 0  'clear sequence
		Endif
		If seq = %10000111 Then  'if sequence corresponds to full click clockwise
			If vol < 255 Then vol = vol + 1
			Gosub sendvol
			seq = 0
		Endif
		pbb = bb  'previous rotary encoder state = current state for next loop comparison
	Endif
	i = i + 1  'increase PWM counter (if i=255 then i=i+1 resets i to 0)
	If i = vol Then
		RB2 = 1  'PWM high when i reaches vol
		If ewc > 0 Then ewc = ewc - 1  'decrease eeprom write delay counter
		If ewc = 1 Then  'counter reached 1 means 10 seconds without vol change
			Write 0, vol  'write volume value to EEPROM address 0
			RB3 = 0  'ACK LED on
		Endif
	Endif
	If i = 0 And vol > 0 Then RB2 = 0  'PWM low - begining of next pulse
Goto loop

End  'end of the program                          

sendvol:  'I2C transmission subroutine

RB3 = 1  'ACK LED off
ewc = 1000  'set eeprom write delay counter to 10 seconds

For addr = 0 To 7  'for each DAC attenuation register address
	i2c_start:
	Config RB4 = Output  'set SDA line low impedance
	RB4 = 0
	WaitUs 15
	Config RB5 = Output  'set SCL line low impedance - end of I2C START
	RB5 = 0
	
	data = 0x90  'address of DAC chip for writing
	Gosub writei2c  'send data
	data = addr  'address of attenuation register
	Gosub writei2c
	data = 255 - vol  'attenuation level
	Gosub writei2c

	Config RB4 = Output  'set SDA line low impedance - begining of I2C STOP
	RB4 = 0
	WaitUs 15
	Config RB5 = Input  'set SCL line high impedance
	WaitUs 15
	Config RB4 = Input  'set SDA line high impedance - end of I2C STOP
	WaitUs 100
	If ack Then Goto i2c_start  'if ack high (unsuccesful write) repeat I2Cwrite swquence
Next addr
Return                                            

writei2c:
For i2 = 0 To 7  'for each bit in data byte
	d = ShiftLeft(data, i2)
	d = d And %10000000
	If d = %10000000 Then
		Config RB4 = Input  'if bit=1 then set SDA line high impedance
	Else
		Config RB4 = Output  'if bit=0 then set SDA line low impedance
		RB4 = 0
	Endif
	Config RB5 = Input  'set SCL line high impedance - tick bit clock
	WaitUs 15
	Config RB5 = Output  'set SCL line low impedance
	RB5 = 0
Next i2
Config RB4 = Input  'set SDA line high impedance
WaitUs 15
Config RB5 = Input  'set SCL line high impedance
WaitUs 15
ack = RB4  'read (N)ACK from SDA
Config RB5 = Output  'set SCL line low impedance
RB5 = 0
WaitUs 15
Return                                            
